# Class AbstractGraph<V, E>`Abstract`

#### Type Parameters

- #### V extends AbstractVertex<any> = AbstractVertex<any>

- #### E extends AbstractEdge<any> = AbstractEdge<any>

#### Hierarchy

- AbstractGraph
  - DirectedGraph
  - UndirectedGraph

#### Implements

- IAbstractGraph<V, E>

- Defined in src/data-structures/graph/abstract-graph.ts:104

#####
Index

### Constructors

constructor

### Properties

_vertices

### Accessors

vertices

### Methods

_addEdgeOnly
_addVertexOnly
_getVertex
_getVertexId
_setVertices
addEdge
addVertex
bellmanFord
createEdge
createVertex
degreeOf
dijkstra
dijkstraWithoutHeap
edgeSet
edgesOf
floyd
getAllPathsBetween
getEdge
getEndsOfEdge
getMinCostBetween
getMinPathBetween
getNeighbors
getPathSumWeight
getVertex
hasEdge
hasVertex
removeAllVertices
removeEdge
removeVertex
setEdgeWeight
tarjan

## Constructors

### constructor

- new AbstractGraph<V, E>(): AbstractGraph<V, E>

- #### Type Parameters

  - #### V extends AbstractVertex<any, V> = AbstractVertex<any>

  - #### E extends AbstractEdge<any, E> = AbstractEdge<any>

  #### Returns AbstractGraph<V, E>

## Properties

### `Private` _vertices

_vertices: Map<VertexId, V> = ...

- Defined in src/data-structures/graph/abstract-graph.ts:109

## Accessors

### vertices

- get vertices(): Map<VertexId, V>

- #### Returns Map<VertexId, V>

  - Defined in src/data-structures/graph/abstract-graph.ts:111

## Methods

### `Protected` `Abstract` _addEdgeOnly

- _addEdgeOnly(edge): boolean

- #### Parameters

  - ##### edge: E

  #### Returns boolean

  - Defined in src/data-structures/graph/abstract-graph.ts:1017

### `Protected` _addVertexOnly

- _addVertexOnly(newVertex): boolean

- #### Parameters

  - ##### newVertex: V

  #### Returns boolean

  - Defined in src/data-structures/graph/abstract-graph.ts:1019

### `Protected` _getVertex

- _getVertex(vertexOrId): null | V

- #### Parameters

  - ##### vertexOrId: VertexId | V

  #### Returns null | V

  - Defined in src/data-structures/graph/abstract-graph.ts:1028

### `Protected` _getVertexId

- _getVertexId(vertexOrId): VertexId

- #### Parameters

  - ##### vertexOrId: VertexId | V

  #### Returns VertexId

  - Defined in src/data-structures/graph/abstract-graph.ts:1033

### `Protected` _setVertices

- _setVertices(value): void

- #### Parameters

  - ##### value: Map<VertexId, V>

  #### Returns void

  - Defined in src/data-structures/graph/abstract-graph.ts:1037

### addEdge

- addEdge(edge): boolean

- #### Parameters

  - ##### edge: E

  #### Returns boolean

  Implementation of IAbstractGraph.addEdge

  - Defined in src/data-structures/graph/abstract-graph.ts:220
- addEdge(src, dest, weight?, val?): boolean

- #### Parameters

  - ##### src: VertexId | V

  - ##### dest: VertexId | V

  - ##### `Optional` weight: number

  - ##### `Optional` val: E["val"]

  #### Returns boolean

  Implementation of IAbstractGraph.addEdge

  - Defined in src/data-structures/graph/abstract-graph.ts:222

### addVertex

- addVertex(vertex): boolean

- #### Parameters

  - ##### vertex: V

  #### Returns boolean

  Implementation of IAbstractGraph.addVertex

  - Defined in src/data-structures/graph/abstract-graph.ts:168
- addVertex(id, val?): boolean

- #### Parameters

  - ##### id: VertexId

  - ##### `Optional` val: V["val"]

  #### Returns boolean

  Implementation of IAbstractGraph.addVertex

  - Defined in src/data-structures/graph/abstract-graph.ts:170

### bellmanFord

- bellmanFord(src, scanNegativeCycle?, getMin?, genPath?): {
  distMap: Map<V, number>;
  hasNegativeCycle: undefined | boolean;
  min: number;
  minPath: V[];
  paths: V[][];
  preMap: Map<V, V>;
  }

- BellmanFord time:O(VE) space:O(V) one to rest pairs /

  /** BellmanFord time:O(VE) space:O(V) one to rest pairs The Bellman-Ford algorithm is also used to find the shortest paths from a source node to all other nodes in a graph. Unlike Dijkstra's algorithm, it can handle edge weights that are negative. Its basic idea involves iterative relaxation of all edges for several rounds to gradually approximate the shortest paths. Due to its ability to handle negative-weight edges, the Bellman-Ford algorithm is more flexible in some scenarios. The `bellmanFord` function implements the Bellman-Ford algorithm to find the shortest path from a source vertex to all other vertices in a graph, and optionally detects negative cycles and generates the minimum path.

  #### Parameters

  - ##### src: VertexId | V

    The `src` parameter is the source vertex from which the Bellman-Ford algorithm will start calculating the shortest paths. It can be either a vertex object or a vertex ID.

  - ##### `Optional` scanNegativeCycle: boolean

    A boolean flag indicating whether to scan for negative cycles in the graph.

  - ##### `Optional` getMin: boolean

    The `getMin` parameter is a boolean flag that determines whether the algorithm should calculate the minimum distance from the source vertex to all other vertices in the graph. If `getMin` is set to `true`, the algorithm will find the minimum distance and update the `min` variable with the minimum

  - ##### `Optional` genPath: boolean

    A boolean flag indicating whether to generate paths for all vertices from the source vertex.

  #### Returns {
  distMap: Map<V, number>;
  hasNegativeCycle: undefined | boolean;
  min: number;
  minPath: V[];
  paths: V[][];
  preMap: Map<V, V>;
  }

  The function `bellmanFord` returns an object with the following properties:

  - ##### distMap: Map<V, number>

  - ##### hasNegativeCycle: undefined | boolean

  - ##### min: number

  - ##### minPath: V[]

  - ##### paths: V[][]

  - ##### preMap: Map<V, V>

  - Defined in src/data-structures/graph/abstract-graph.ts:725

### `Abstract` createEdge

- createEdge(srcOrV1, destOrV2, weight?, val?): E

- In TypeScript, a subclass inherits the interface implementation of its parent class, without needing to implement the same interface again in the subclass. This behavior differs from Java's approach. In Java, if a parent class implements an interface, the subclass needs to explicitly implement the same interface, even if the parent class has already implemented it. This means that using abstract methods in the parent class cannot constrain the grandchild classes. Defining methods within an interface also cannot constrain the descendant classes. When inheriting from this class, developers need to be aware that this method needs to be overridden.

  #### Parameters

  - ##### srcOrV1: VertexId

  - ##### destOrV2: VertexId

  - ##### `Optional` weight: number

  - ##### `Optional` val: E

  #### Returns E

  - Defined in src/data-structures/graph/abstract-graph.ts:131

### `Abstract` createVertex

- createVertex(id, val?): V

- In TypeScript, a subclass inherits the interface implementation of its parent class, without needing to implement the same interface again in the subclass. This behavior differs from Java's approach. In Java, if a parent class implements an interface, the subclass needs to explicitly implement the same interface, even if the parent class has already implemented it. This means that using abstract methods in the parent class cannot constrain the grandchild classes. Defining methods within an interface also cannot constrain the descendant classes. When inheriting from this class, developers need to be aware that this method needs to be overridden.

  #### Parameters

  - ##### id: VertexId

  - ##### `Optional` val: V

  #### Returns V

  - Defined in src/data-structures/graph/abstract-graph.ts:121

### `Abstract` degreeOf

- degreeOf(vertexOrId): number

- #### Parameters

  - ##### vertexOrId: VertexId | V

  #### Returns number

  Implementation of IAbstractGraph.degreeOf

  - Defined in src/data-structures/graph/abstract-graph.ts:137

### dijkstra

- dijkstra(src, dest?, getMinDist?, genPaths?): DijkstraResult<V>

- Dijkstra algorithm time: O(logVE) space: O(V + E)

  Dijkstra's algorithm only solves the single-source shortest path problem, while the Bellman-Ford algorithm and Floyd-Warshall algorithm can address shortest paths between all pairs of nodes. Dijkstra's algorithm is suitable for graphs with non-negative edge weights, whereas the Bellman-Ford algorithm and Floyd-Warshall algorithm can handle negative-weight edges. The time complexity of Dijkstra's algorithm and the Bellman-Ford algorithm depends on the size of the graph, while the time complexity of the Floyd-Warshall algorithm is O(V^3), where V is the number of nodes. For dense graphs, Floyd-Warshall might become slower.

  /

  /** Dijkstra's algorithm is used to find the shortest paths from a source node to all other nodes in a graph. Its basic idea is to repeatedly choose the node closest to the source node and update the distances of other nodes using this node as an intermediary. Dijkstra's algorithm requires that the edge weights in the graph are non-negative. The `dijkstra` function implements Dijkstra's algorithm to find the shortest path between a source vertex and an optional destination vertex, and optionally returns the minimum distance, the paths, and other information.

  #### Parameters

  - ##### src: VertexId | V

    The `src` parameter represents the source vertex from which the Dijkstra algorithm will start. It can be either a vertex object or a vertex ID.

  - ##### `Optional` dest: null | VertexId | V

    The `dest` parameter is the destination vertex or vertex ID. It specifies the vertex to which the shortest path is calculated from the source vertex. If no destination is provided, the algorithm will calculate the shortest paths to all other vertices from the source vertex.

  - ##### `Optional` getMinDist: boolean

    The `getMinDist` parameter is a boolean flag that determines whether the minimum distance from the source vertex to the destination vertex should be calculated and returned in the result. If `getMinDist` is set to `true`, the `minDist` property in the result will contain the minimum distance

  - ##### `Optional` genPaths: boolean

    The `genPaths` parameter is a boolean flag that determines whether or not to generate paths in the Dijkstra algorithm. If `genPaths` is set to `true`, the algorithm will calculate and return the shortest paths from the source vertex to all other vertices in the graph. If `genPaths @returns The function` dijkstra`returns an object of type`DijkstraResult`.

  #### Returns DijkstraResult<V>

  - Defined in src/data-structures/graph/abstract-graph.ts:596

### dijkstraWithoutHeap

- dijkstraWithoutHeap(src, dest?, getMinDist?, genPaths?): DijkstraResult<V>

- Dijkstra algorithm time: O(VE) space: O(V + E) /

  /** Dijkstra algorithm time: O(VE) space: O(V + E) The function `dijkstraWithoutHeap` implements Dijkstra's algorithm to find the shortest path between two vertices in a graph without using a heap data structure.

  #### Parameters

  - ##### src: VertexId | V

    The source vertex from which to start the Dijkstra's algorithm. It can be either a vertex object or a vertex ID.

  - ##### `Optional` dest: null | VertexId | V

    The `dest` parameter in the `dijkstraWithoutHeap` function is an optional parameter that specifies the destination vertex for the Dijkstra algorithm. It can be either a vertex object or its identifier. If no destination is provided, the value is set to `null`.

  - ##### `Optional` getMinDist: boolean

    The `getMinDist` parameter is a boolean flag that determines whether the minimum distance from the source vertex to the destination vertex should be calculated and returned in the result. If `getMinDist` is set to `true`, the `minDist` property in the result will contain the minimum distance

  - ##### `Optional` genPaths: boolean

    The `genPaths` parameter is a boolean flag that determines whether or not to generate paths in the Dijkstra algorithm. If `genPaths` is set to `true`, the algorithm will calculate and return the shortest paths from the source vertex to all other vertices in the graph. If `genPaths @returns The function` dijkstraWithoutHeap`returns an object of type`DijkstraResult`.

  #### Returns DijkstraResult<V>

  - Defined in src/data-structures/graph/abstract-graph.ts:456

### `Abstract` edgeSet

- edgeSet(): E[]

- #### Returns E[]

  Implementation of IAbstractGraph.edgeSet

  - Defined in src/data-structures/graph/abstract-graph.ts:139

### `Abstract` edgesOf

- edgesOf(vertexOrId): E[]

- #### Parameters

  - ##### vertexOrId: VertexId | V

  #### Returns E[]

  Implementation of IAbstractGraph.edgesOf

  - Defined in src/data-structures/graph/abstract-graph.ts:141

### floyd

- floyd(): {
  costs: number[][];
  predecessor: (null | V)[][];
  }

- Floyd algorithm time: O(V^3) space: O(V^2), not support graph with negative weight cycle all pairs /

  /** Floyd algorithm time: O(V^3) space: O(V^2), not support graph with negative weight cycle all pairs The Floyd-Warshall algorithm is used to find the shortest paths between all pairs of nodes in a graph. It employs dynamic programming to compute the shortest paths from any node to any other node. The Floyd-Warshall algorithm's advantage lies in its ability to handle graphs with negative-weight edges, and it can simultaneously compute shortest paths between any two nodes. The function implements the Floyd-Warshall algorithm to find the shortest path between all pairs of vertices in a graph.

  #### Returns {
  costs: number[][];
  predecessor: (null | V)[][];
  }

  The function `floyd()` returns an object with two properties: `costs` and `predecessor`. The `costs` property is a 2D array of numbers representing the shortest path costs between vertices in a graph. The `predecessor` property is a 2D array of vertices (or `null`) representing the predecessor vertices in the shortest path between vertices in the

  - ##### costs: number[][]

  - ##### predecessor: (null | V)[][]

  - Defined in src/data-structures/graph/abstract-graph.ts:851

### getAllPathsBetween

- getAllPathsBetween(v1, v2): V[][]

- The function `getAllPathsBetween` finds all paths between two vertices in a graph using depth-first search.

  #### Parameters

  - ##### v1: VertexId | V

    The parameter `v1` represents either a vertex object (`V`) or a vertex ID (`VertexId`). It is the starting vertex for finding paths.

  - ##### v2: VertexId | V

    The parameter `v2` represents either a vertex object (`V`) or a vertex ID (`VertexId`).

  #### Returns V[][]

  The function `getAllPathsBetween` returns an array of arrays of vertices (`V[][]`).

  - Defined in src/data-structures/graph/abstract-graph.ts:268

### `Abstract` getEdge

- getEdge(srcOrId, destOrId): null | E

- #### Parameters

  - ##### srcOrId: VertexId | V

  - ##### destOrId: VertexId | V

  #### Returns null | E

  Implementation of IAbstractGraph.getEdge

  - Defined in src/data-structures/graph/abstract-graph.ts:135

### `Abstract` getEndsOfEdge

- getEndsOfEdge(edge): null | [V, V]

- #### Parameters

  - ##### edge: E

  #### Returns null | [V, V]

  - Defined in src/data-structures/graph/abstract-graph.ts:145

### getMinCostBetween

- getMinCostBetween(v1, v2, isWeight?): null | number

- The function `getMinCostBetween` calculates the minimum cost between two vertices in a graph, either based on edge weights or using a breadth-first search algorithm.

  #### Parameters

  - ##### v1: VertexId | V

    The parameter `v1` represents the starting vertex or its ID.

  - ##### v2: VertexId | V

    The parameter `v2` represents the destination vertex or its ID. It is the vertex to which you want to find the minimum cost or weight from the source vertex `v1`.

  - ##### `Optional` isWeight: boolean

    isWeight is an optional parameter that indicates whether the graph edges have weights. If isWeight is set to true, the function will calculate the minimum cost between v1 and v2 based on the weights of the edges. If isWeight is set to false or not provided, the function will calculate the

  #### Returns null | number

  The function `getMinCostBetween` returns a number representing the minimum cost between two vertices (`v1` and `v2`). If the `isWeight` parameter is `true`, it calculates the minimum weight among all paths between the vertices. If `isWeight` is `false` or not provided, it uses a breadth-first search (BFS) algorithm to calculate the minimum number of

  - Defined in src/data-structures/graph/abstract-graph.ts:326

### getMinPathBetween

- getMinPathBetween(v1, v2, isWeight?): null | V[]

- The function `getMinPathBetween` returns the minimum path between two vertices in a graph, either based on weight or using a breadth-first search algorithm.

  #### Parameters

  - ##### v1: VertexId | V

    The parameter `v1` represents the starting vertex of the path. It can be either a vertex object (`V`) or a vertex ID (`VertexId`).

  - ##### v2: VertexId | V

    V | VertexId - The second vertex or vertex ID between which we want to find the minimum path.

  - ##### `Optional` isWeight: boolean

    A boolean flag indicating whether to consider the weight of edges in finding the minimum path. If set to true, the function will use Dijkstra's algorithm to find the minimum weighted path. If set to false, the function will use breadth-first search (BFS) to find the minimum path.

  #### Returns null | V[]

  The function `getMinPathBetween` returns an array of vertices (`V[]`) representing the minimum path between two vertices (`v1` and `v2`). If there is no path between the vertices, it returns `null`.

  Implementation of IAbstractGraph.getMinPathBetween

  - Defined in src/data-structures/graph/abstract-graph.ts:384

### `Abstract` getNeighbors

- getNeighbors(vertexOrId): V[]

- #### Parameters

  - ##### vertexOrId: VertexId | V

  #### Returns V[]

  Implementation of IAbstractGraph.getNeighbors

  - Defined in src/data-structures/graph/abstract-graph.ts:143

### getPathSumWeight

- getPathSumWeight(path): number

- The function calculates the sum of weights along a given path.

  #### Parameters

  - ##### path: V[]

    An array of vertices (V) representing a path in a graph.

  #### Returns number

  The function `getPathSumWeight` returns the sum of the weights of the edges in the given path.

  - Defined in src/data-structures/graph/abstract-graph.ts:304

### getVertex

- getVertex(vertexId): null | V

- The function "getVertex" returns the vertex with the specified ID or null if it doesn't exist.

  #### Parameters

  - ##### vertexId: VertexId

    The `vertexId` parameter is the identifier of the vertex that you want to retrieve from the `_vertices` map.

  #### Returns null | V

  The method `getVertex` returns the vertex with the specified `vertexId` if it exists in the `_vertices` map. If the vertex does not exist, it returns `null`.

  - Defined in src/data-structures/graph/abstract-graph.ts:154

### hasEdge

- hasEdge(v1, v2): boolean

- The function checks if there is an edge between two vertices and returns a boolean value indicating the result.

  #### Parameters

  - ##### v1: VertexId | V

    The parameter v1 can be either a VertexId or a V. A VertexId represents the unique identifier of a vertex in a graph, while V represents the type of the vertex object itself.

  - ##### v2: VertexId | V

    The parameter `v2` represents the second vertex in the edge. It can be either a `VertexId` or a `V` type, which represents the type of the vertex.

  #### Returns boolean

  A boolean value is being returned.

  Implementation of IAbstractGraph.hasEdge

  - Defined in src/data-structures/graph/abstract-graph.ts:215

### hasVertex

- hasVertex(vertexOrId): boolean

- The function checks if a vertex exists in a graph.

  #### Parameters

  - ##### vertexOrId: VertexId | V

    The parameter `vertexOrId` can be either a vertex object (`V`) or a vertex ID (`VertexId`).

  #### Returns boolean

  a boolean value.

  Implementation of IAbstractGraph.hasVertex

  - Defined in src/data-structures/graph/abstract-graph.ts:164

### removeAllVertices

- removeAllVertices(vertices): boolean

- The function removes all vertices from a graph and returns a boolean indicating if any vertices were removed.

  #### Parameters

  - ##### vertices: VertexId[] | V[]

    The `vertices` parameter can be either an array of vertices (`V[]`) or an array of vertex IDs (`VertexId[]`).

  #### Returns boolean

  a boolean value. It returns true if at least one vertex was successfully removed, and false if no vertices were removed.

  Implementation of IAbstractGraph.removeAllVertices

  - Defined in src/data-structures/graph/abstract-graph.ts:199

### `Abstract` removeEdge

- removeEdge(edge): null | E

- #### Parameters

  - ##### edge: E

  #### Returns null | E

  Implementation of IAbstractGraph.removeEdge

  - Defined in src/data-structures/graph/abstract-graph.ts:133

### removeVertex

- removeVertex(vertexOrId): boolean

- The `removeVertex` function removes a vertex from a graph by its ID or by the vertex object itself.

  #### Parameters

  - ##### vertexOrId: VertexId | V

    The parameter `vertexOrId` can be either a vertex object (`V`) or a vertex ID (`VertexId`).

  #### Returns boolean

  The method is returning a boolean value.

  Implementation of IAbstractGraph.removeVertex

  - Defined in src/data-structures/graph/abstract-graph.ts:187

### setEdgeWeight

- setEdgeWeight(srcOrId, destOrId, weight): boolean

- The function sets the weight of an edge between two vertices in a graph.

  #### Parameters

  - ##### srcOrId: VertexId | V

    The `srcOrId` parameter can be either a `VertexId` or a `V` object. It represents the source vertex of the edge.

  - ##### destOrId: VertexId | V

    The `destOrId` parameter represents the destination vertex of the edge. It can be either a `VertexId` or a vertex object `V`.

  - ##### weight: number

    The weight parameter represents the weight of the edge between the source vertex (srcOrId) and the destination vertex (destOrId).

  #### Returns boolean

  a boolean value. If the edge exists between the source and destination vertices, the function will update the weight of the edge and return true. If the edge does not exist, the function will return false.

  Implementation of IAbstractGraph.setEdgeWeight

  - Defined in src/data-structures/graph/abstract-graph.ts:251

### tarjan

- tarjan(needArticulationPoints?, needBridges?, needSCCs?, needCycles?): {
  SCCs: Map<number, V[]>;
  articulationPoints: V[];
  bridges: E[];
  cycles: Map<number, V[]>;
  dfnMap: Map<V, number>;
  lowMap: Map<V, number>;
  }

- Tarjan is an algorithm based on DFS,which is used to solve the connectivity problem of graphs. Tarjan can find cycles in directed or undirected graph Tarjan can find the articulation points and bridges(critical edges) of undirected graphs in linear time, Tarjan solve the bi-connected components of undirected graphs; Tarjan can find the SSC(strongly connected components), articulation points, and bridges of directed graphs. /

  /** Tarjan is an algorithm based on DFS,which is used to solve the connectivity problem of graphs. Tarjan can find cycles in directed or undirected graph Tarjan can find the articulation points and bridges(critical edges) of undirected graphs in linear time, Tarjan solve the bi-connected components of undirected graphs; Tarjan can find the SSC(strongly connected components), articulation points, and bridges of directed graphs. The `tarjan` function is used to perform various graph analysis tasks such as finding articulation points, bridges, strongly connected components (SCCs), and cycles in a graph.

  #### Parameters

  - ##### `Optional` needArticulationPoints: boolean

    A boolean value indicating whether or not to calculate and return the articulation points in the graph. Articulation points are the vertices in a graph whose removal would increase the number of connected components in the graph.

  - ##### `Optional` needBridges: boolean

    A boolean flag indicating whether the algorithm should find and return the bridges (edges whose removal would increase the number of connected components in the graph).

  - ##### `Optional` needSCCs: boolean

    A boolean value indicating whether the Strongly Connected Components (SCCs) of the graph are needed. If set to true, the function will calculate and return the SCCs of the graph. If set to false, the SCCs will not be calculated or returned.

  - ##### `Optional` needCycles: boolean

    A boolean flag indicating whether the algorithm should find cycles in the graph. If set to true, the algorithm will return a map of cycles, where the keys are the low values of the SCCs and the values are arrays of vertices that form cycles within the SCCs.

  #### Returns {
  SCCs: Map<number, V[]>;
  articulationPoints: V[];
  bridges: E[];
  cycles: Map<number, V[]>;
  dfnMap: Map<V, number>;
  lowMap: Map<V, number>;
  }

  The function `tarjan` returns an object with the following properties:

  - ##### SCCs: Map<number, V[]>

  - ##### articulationPoints: V[]

  - ##### bridges: E[]

  - ##### cycles: Map<number, V[]>

  - ##### dfnMap: Map<V, number>

  - ##### lowMap: Map<V, number>

  - Defined in src/data-structures/graph/abstract-graph.ts:915

Generated using TypeDoc